.\" $NetBSD$
.\"
.\" Copyright (c) 2000 Alfred Perlstein
.\"
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/accf_http.9,v 1.11 2005/01/18 20:52:51 ru Exp $
.\" "
.Dd September 4, 2008
.Dt ACCF_HTTP 9
.Os
.Sh NAME
.Nm accf_http
.Nd "buffer incoming connections until a certain complete HTTP requests arrive"
.Sh SYNOPSIS
.Cd "options INET"
.Cd "pseudo-device accf_http"
.Sh DESCRIPTION
This is a filter to be placed on a socket that will be using
.Fn accept
to receive incoming HTTP connections.
.Pp
Once installed on a listening socket, this filter is activated when a
connection becomes ready to receive data (at which point
.Xr accept 2
would usually return the connected descriptor to the application).
The filter prevents the descriptor from being returned immediately
to the application via
.Xr accept 2 .
The descriptor is made available to the application via
.Xr accept 2
only when one of the following conditions is met:
.Bl -enum
.It
A complete, syntactically valid HTTP/1.0 or HTTP/1.1 HEAD or GET request has
been buffered by the kernel.
.It
The data buffered by the kernel cannot be part of a complete, syntactically
valid HTTP 1.0 or HTTP/1.1 HEAD or GET request.
.El
.Pp
The utility of
.Nm
is that a server will not have to context switch several times
before performing the initial parsing of the request.
This effectively reduces the amount of required CPU utilization
to handle incoming requests by keeping active
processes in preforking servers such as Apache low
and reducing the size of the file descriptor set that needs
to be managed by interfaces such as
.Fn select ,
.Fn poll
or
.Fn kevent
based servers.
.Sh EXAMPLES
If the accf_data accept filter is present in the kernel configuration,
this will enable the http accept filter
on the socket
.Fa sok .
.Bd -literal -offset 0i
	struct accept_filter_arg afa;

	bzero(\*[Am]afa, sizeof(afa));
	strcpy(afa.af_name, "httpready");
	setsockopt(sok, SOL_SOCKET, SO_ACCEPTFILTER, \*[Am]afa, sizeof(afa));
.Ed
.Sh SEE ALSO
.Xr setsockopt 2 ,
.Xr accept_filter 9
.Sh HISTORY
The accept filter mechanism and the
accf_http filter were introduced in
.Fx 4.0 .
They were ported to
.Nx
by Coyote Point Systems and appeared in
.Nx 5.0 .
.Sh AUTHORS
This manual page and the filter were written by
.An Alfred Perlstein .
